function stoermerverlet

% initialisation
N=100;
T=10;
h=T/N;

% function f
f=@(y) -sin(y);

% initial condition
v0=0;
y0=pi/2;

% prepare arrays
v=zeros(N+1,1);
y=zeros(N+1,1);

% set initial conditions
v(1)=v0;
y(1)=y0;

% functions and vectors for solving the differential equation
F=@(y,Y) Y*(-cos(y));
V=zeros(2,N+1);
Y=zeros(2,N+1);
V(:,1)=[0;1];
Y(:,1)=[1;0];
detW=zeros(N+1,1);
detW(1)=det([Y(:,1)';V(:,1)']);

for ii=1:N
% solve the IVP
    v05=v(ii)+h/2*f(y(ii));
    y(ii+1)=y(ii)+h*v05;
    v(ii+1)=v05+h/2*f(y(ii+1));
    
% Solve the variational equation
    V05=V(:,ii)+h/2*F(y(ii),Y(:,ii));
    Y(:,ii+1)=Y(:,ii)+h*V05;
    V(:,ii+1)=V05+h/2*F(y(ii+1),Y(:,ii+1));
    
% compute the determinant of the Wronskian
    detW(ii+1)=det([Y(:,ii+1)';V(:,ii+1)']);
    
end

% plot the evolution of the determinant
figure;
plot(0:h:T,detW,'*')
ylim([0 2])
max(detW)-1