% script for plotting numerical solutions

% Invariant
I=@(p,q) -imag(log(p+i*q));

%  time intervall
Tspan=[0 100];

% initial data
p0=3;
q0=4;

h=1/2;

[t1,p1,q1]=RK4(p0,q0,Tspan,h);
[t2,p2,q2]=SympEuler(p0,q0,Tspan,h);

I1=I(p1,q1);
I2=I(p2,q2);

figure;
plot(t1,I1,'r*-',t2,I2,'b+-');
xlabel('t'); ylabel('Energy');
legend('RK4','Sympl Euler');
print -depsc energy.eps

figure; plot(p1,q1,'r*-');
xlabel('p'); ylabel('q');
legend('RK4');
print -depsc RK4.eps

figure; plot(p2,q2,'b*-');
xlabel('p'); ylabel('q');
legend('SympEuler');
print -depsc SympEuler.eps
